//+------------------------------------------------------------------+ 
//|   TRO_DRAGON_MONEY_MGMT                                          | 
//|                                                                  | 
//|   Copyright  2008, Avery T. Horton, Jr. aka TheRumpledOne       |
//|                                                                  |
//|   PO BOX 43575, TUCSON, AZ 85733                                 |
//|                                                                  |
//|   GIFTS AND DONATIONS ACCEPTED                                   | 
//|   All my indicators should be considered donationware. That is   |
//|   you are free to use them for your personal use, and are        |
//|   under no obligation to pay for them. Howeverow, if you do find |
//|   this or any of my other indicators help you with your trading  |
//|   then any Gift or Donation as a show of appreciation is         |
//|   gratefully accepted.                                           |
//|                                                                  |
//|   Gifts or Donations also keep me motivated in producing more    |
//|   great free indicators. :-)                                     |
//|                                                                  |
//|   PayPal - THERUMPLEDONE@GMAIL.COM                               |  
//+------------------------------------------------------------------+  
/*

MODIFIED BY SNSCOTT TO DEMONSTRATE THE SNS_TABLE_OBJECT

*/

 
// The following INCLUDE HEADER FILES need to be in the EXPERTS\INCLUDES Folder
#include <SNS_TABLE_OBJECT.mqh>
#include <SNS_ObjectLibrary.mqh>

#property indicator_chart_window


#define ROWS 10
#define COLUMNS 2

extern string 		Table.Title								=	"MoneyMan";

extern int			Table.Window							=  0;
extern int			Table.Corner							=  0;
extern int			Table.X									=	10;
extern int			Table.Y									=  20;
extern bool			Table.Back								=  false;

						// List Column (X) and Row (Y) values as string with values separated by semi-colons
extern string		Table.Columns 							=	"0;140";
extern string		Table.Rows 								=  "0;25;50;70;100;125;150;175;200;225";

						// List Cell Font attributes as a string with values separated by semi-colons - any left off are set to the DEFAULT values in Table.Initialize()
extern string		Cell.Fonts 								=	"Verdana Bold;Verdana;Verdana;Verdana;Verdana;Verdana;Verdana Bold";			
extern string		Cell.FontSizes							=	"14;0;12;12;12;12;14;14";	
extern string		Cell.FontColors						=  "RoyalBlue;RoyalBlue;Orange;Orange;Gold;Gold;White;White;Red;Tomato;Red;Red;Orange;Orange;Orange;Orange;SteelBlue;SteelBlue;Orange;Orange";	

   
extern bool      	use.actual.balance  					= true ; 
extern double    	my.Account.Size       				= 0 ;
extern double		my.Lot.Size								= 0 ;
extern double    	my.StopLossPips      				= 10 ;
extern double    	my.Multiplier1       				= 10 ;
extern double    	my.Multiplier2       				= 2  ;
extern double    	my.RiskPct           				= 2 ;

int     row,digits; 
 
double point, Account.Size, Lot.Size, RiskPct, Risk, AmountPerPip;    

double Lot.Value,Tick.Value, Tick.Adjusted, Tick.Size, Margin.Required;  

string tag = "SNS_MM:", symbol;

bool Table.Initialized=false;

color Color.Account;

 
//____________________________________________________________________________________________________________________________________________________________
int init() {
	
	symbol = Symbol();
   digits =  Digits ;
   point  =  Point ;

   if(digits == 5 || digits == 3) { digits = digits - 1 ; point = point * 10 ; }
   
   deinit();
   
	Table.Initialize(Table.Title);
   
   ShowData();

   return(0);
   
}

  
//____________________________________________________________________________________________________________________________________________________________
int deinit(){

 	Table.Deinit();
   DeleteObjectsByPrefix(tag);   
 
   return(0);
   
}
 
//____________________________________________________________________________________________________________________________________________________________
int start(){
 
   return(ShowData());
   
}


//************************************************************************************************************************************************************
//CUSTOM INDICATOR FUNCTIONS

//____________________________________________________________________________________________________________________________________________________________
//INITIALIZE THE TABLE OBJECT USING EXTERN PARAMETERS PROVIDED BY *THIS* INDICATOR 

void Table.Initialize(string name){

	string f[],fonts[ROWS][COLUMNS],fcolors[];
	color colors[ROWS][COLUMNS];
	int cols[],rows[],fsizes[],sizes[ROWS][COLUMNS];
	
	String.ToIntArray(cols,Table.Columns);
	String.ToIntArray(rows,Table.Rows);
	
	Table.SetCorner(Table.Corner);
		
	if (Table.Init(name,rows,cols)<0) Print("TABLE FAILED TO INITIALIZE"); else Table.Initialized=true;

	// convert EXTERN string "arrays" into "real" arrays (because MT4 does not provide for EXTERN of array variables)
	int fas = String.ToArray(f,Cell.Fonts);
	int fss = String.ToIntArray(fsizes,Cell.FontSizes);
	int fcs = String.ToArray(fcolors,Cell.FontColors);
	

	//Plug values from one-dimensional arrays into corresponding two-dimensional cell arrays
	int i=0;
	for (int r=0; r<ROWS; r++) {
	
		for(int c=0; c<COLUMNS; c++) {
		
			if(i<fas) fonts[r,c]=f[i];
			if(i<fss) sizes[r,c]=fsizes[i];
			if(i<fcs) colors[r,c]=String.ToColor(fcolors[i]);
			i++;
		
		}
	
	}
		
	Table.SetFonts(fonts);
	Table.SetFontColors(colors);
	Table.SetFontSizes(sizes);
	
	// Now run through cells and find any that were not set (missing from EXTERN string) and set their properties to these DEFAULT values:
	Table.SetDefaultFont("Verdana",12,White);
	
}


//____________________________________________________________________________________________________________________________________________________________
  
void DoCalcs()	{

	RefreshRates();   
	
	Lot.Value       = MarketInfo(symbol,MODE_LOTSIZE) ;   
	Tick.Size       = MarketInfo(symbol,MODE_TICKSIZE) ;    
	Margin.Required  = MarketInfo(symbol,MODE_MARGINREQUIRED) ;
	
	double yvalue		=  MarketInfo(symbol,MODE_TICKVALUE) ;

	double TICKVALUE  =  ( Lot.Value  / yvalue ) / 1000  ; 

	double xvalue     =  Lot.Value / 100000.00 ;

	Tick.Value =  yvalue * xvalue ; 

	if( use.actual.balance == true ) Account.Size = AccountBalance() ;  
	else  if( my.Account.Size == 0 ) { Account.Size = my.StopLossPips * my.Multiplier1 * my.Multiplier2  ; } 
       	else Account.Size = my.Account.Size;

	if( my.RiskPct == 0 ) { RiskPct = 100 * ( my.StopLossPips * my.Lot.Size * Tick.Value * 10 ) / Account.Size ; } else { RiskPct = my.RiskPct ; }

	Risk  = (RiskPct * Account.Size) / 100  ;

	if( my.RiskPct == 0 ) Lot.Size=my.Lot.Size; else Lot.Size = Risk / (my.StopLossPips*Tick.Value*10);
	
	AmountPerPip = Lot.Size * Tick.Value * 10 ;
	
	Tick.Adjusted=AmountPerPip/10;
	
	int error = GetLastError();
	if (error!=0) Print("MM ERROR:" + error);

} 


//____________________________________________________________________________________________________________________________________________________________
  
int ShowData(){

	row=0;
	Table.SetText(row,0,"MONEY MANAGEMENT:" + Symbol()); row++;

	DoCalcs() ; 
	
	if (Account.Size<=Margin.Required*2) Color.Account=Red; else Color.Account=Green;
	

	Table.SetText(row,0,"Lot Size"); 									Table.SetText(row,1,"$"+DoubleToStr(Lot.Value,2)); 														row++;
	Table.SetText(row,0,"Margin per Lot");								Table.SetText(row,1,"$"+DoubleToStr(Margin.Required,2)); 													row++;
	Table.SetTextOverride(row,0,"Account","",0,Color.Account); 	Table.SetTextOverride(row,1,"$"+DoubleToStr(Account.Size,2),"",0,Color.Account); 					row++;
	Table.SetText(row,0,"Risk %"); 										Table.SetText(row,1,DoubleToStr(RiskPct,2)+"%"); 															row++;
	Table.SetText(row,0,"Risk $"); 										Table.SetText(row,1,"$"+DoubleToStr(Risk,2)); 																row++;
	Table.SetText(row,0,"SL/TP"); 										Table.SetText(row,1,DoubleToStr(my.StopLossPips,2)+" pips"); 											row++;
	Table.SetText(row,0,"Lot Trade Size");								Table.SetText(row,1,DoubleToStr(Lot.Size,2)); 																row++;
	Table.SetText(row,0,"Tick S/V"); 									Table.SetText(row,1,DoubleToStr(Tick.Value,digits)+"/$"+DoubleToStr(Tick.Adjusted,digits)); 	row++;
	Table.SetText(row,0,"Pip Value"); 									Table.SetText(row,1,"$"+DoubleToStr(AmountPerPip,2)); 													row++;

	WindowRedraw() ;   

   return(0);

}



 

